/*
 * captouch - A demostration program for using capacitive touch sensors
 * Copyright (C) 2012 Andreas AUer <andreas.auer@emicrotec.at>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef CAPTOUCH_H

#define MAX_SENSE_CYCLE         2048
#define FILTER_LENGTH           16
#define FILTER_SHIFT            4

#define TOUCH_PORT              *(config->base+2)
#define TOUCH_DDR               *(config->base+1)
#define TOUCH_PIN               *(config->base+0)
/*
#define TOUCH_PORT              PORTC
#define TOUCH_DDR               DDRC
#define TOUCH_PIN               PINC
*/

#define TOUCH_UP                0
#define TOUCH_DOWN              1

typedef struct TouchConfig_ TouchConfig;
typedef struct TouchKey_ TouchKey;

struct TouchConfig_
{
    volatile unsigned char *base;   // this address must refer to the PINx register
    unsigned char mask_snsk;
    unsigned char mask_sns;
    
    unsigned char filter_time;
    unsigned char filter_counter;
    
    unsigned char first_time;
};

struct TouchKey_
{
    unsigned short current_value;
    unsigned short base_value;
    short delta;

    unsigned char  current_state;

    unsigned short filter_buffer[FILTER_LENGTH];
    unsigned int   filter_value;
    unsigned char  filter_counter;
};

void touchInit(TouchConfig *config);
void touchSense(TouchConfig *config, TouchKey *keys);

#endif

